/* dic2txt.c
 * pomera GNX|[gꂽt@C atok.dic 
 * ATOK8̃[hXg`ɕϊ܂B
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>

#define D_SZ_ATOK_DIC_AREA (33752)

typedef struct tagATREGSTYLEBUF {
    unsigned char uchStyle;         /* iԍ */
    char *pszDescription;           /* i */
} ATREGSTYLEBUF, *PATREGSTYLEBUF, *LPATREGSTYLEBUF;

ATREGSTYLEBUF atgRegStyle[] = {
    {1,  "ʖ"},
    {2,  "ŗLl"},
    {3,  "ŗLn"},
    {4,  "ŗLgD"},
    {5,  "ŗL"},
    {6,  "T"},
    {7,  "U"},
    {8,  "`"},
    {9,  "Ɨ"},
    {10, "P"},
    {11, "A̎"},
    {12, "ڑ"},
    {13, ""},
    {14, "ړ"},
    {15, "ڔ"},
    {16, ""},
    {17, "Jsܒi"},
    {18, "Ksܒi"},
    {19, "Tsܒi"},
    {20, "^sܒi"},
    {21, "isܒi"},
    {22, "nsܒi"},
    {23, "osܒi"},
    {24, "}sܒi"},
    {25, "sܒi"},
    {26, "sܒi"},
    {27, "i"},
    {28, "Jϓ"},
    {29, "Tϓ"},
    {30, "Uϓ"},
    {31, "`e"},
    {32, "`e"},
    {33, ""},
    {0xff, NULL}
};


void useage(char *thispgm) {
    fprintf(stderr, "usegae:\n\t%s <input filename> <output filename>\n", thispgm);
}

void formatToken(FILE *fpOut,
                 unsigned char *pszYOMI,
                 unsigned char *pszKNJ,
                 unsigned char uchH) {
    PATREGSTYLEBUF ptgStyle = atgRegStyle;
    char *pszStyle = ptgStyle->pszDescription;

    /* i̕ϊ */
    do {
        if (ptgStyle->uchStyle == 0xff) break;
        if (ptgStyle->uchStyle == uchH) {
            pszStyle = ptgStyle->pszDescription;
            break;
        }
        ptgStyle++;
    } while (1);
    fprintf(fpOut, "%s,\"%s\",%s\n", pszYOMI, pszKNJ, pszStyle);
}

unsigned char *printToken(FILE *fpOut, unsigned char *puchInp, unsigned char *pchBuf) {
    unsigned char szYOMI[512];
    unsigned char szKNJ[512];
    unsigned char uchK;
    unsigned char uchL;
    unsigned char uchH;
    int i;
    int offset;
    offset = (puchInp - pchBuf);

    memset(szYOMI, 0, sizeof(szYOMI));
    memset(szKNJ, 0, sizeof(szKNJ));
    uchK = *puchInp++;
    uchL = *puchInp++;
    memcpy(szYOMI, puchInp, uchL);
    puchInp = puchInp + uchL;
    if (uchK & 0x80) {
        i = uchK & 0x7f;
        memcpy(szKNJ, puchInp, (i-uchL-1));
        puchInp += (i-uchL-1);
        uchH = 0x01;
    } else {
        i = uchK;
        memcpy(szKNJ, puchInp, (i-uchL-2));
        puchInp += (i-uchL-2);
        uchH = *puchInp++;
    }
    formatToken(fpOut, szYOMI, szKNJ, uchH);
    return puchInp;
}

int analizeMain(FILE *fpOut, unsigned char *pchBuf) {
    int rc;
    int iOffset;
    unsigned char *puchInp;
    unsigned char *puchEnd;
    short *ps;
    int iLen;
    int i;

    rc = 0; /* normal return code */
    fprintf(fpOut, "!ATOK8\n\n");

    iOffset = 0x2614;
    puchInp = &pchBuf[iOffset];
    ps = (short *)&pchBuf[0x2410];
    iLen = (int)*ps;
    puchEnd = pchBuf + iLen + 0x2614;
    do {
        puchInp = printToken(fpOut, puchInp, pchBuf);
    } while(puchInp < puchEnd);
    return rc;
}

int main(int argc, char **argv) {
    int rc;
    char *atokfname;
    char *fnameOut;
    int fhInp;
    unsigned char *puchReadBuffer;
    int iLen;
    FILE *fpOut;

    /* init */
    rc = 11;    /* Ill arg. */
    puchReadBuffer = NULL;

    if (argc < 3) {
        useage(argv[0]);
        return rc;
    }
    atokfname = argv[1];
    if (atokfname == NULL) {
        useage(argv[0]);
        return rc;
    }
    fnameOut = argv[2];
    if (fnameOut == NULL) {
        useage(argv[0]);
        return rc;
    }

    /* get resource */
    rc = 3; /* fatal error */
    puchReadBuffer = (char *)malloc(D_SZ_ATOK_DIC_AREA + 1);
    if (puchReadBuffer == NULL) {
        /* resource failed. goto error processing. */
        return rc;
    }
    memset(puchReadBuffer, 0, D_SZ_ATOK_DIC_AREA); /* ̈NA */
    /* file open */
    rc = 4; /* read error */
    fhInp = open(atokfname, O_RDONLY|O_BINARY);
    if (fhInp < 0) {
        fprintf(stderr, "t@C[%s]J܂\n", atokfname);
        goto ERROR_EXIT;
    }
    /* ̓Ǎ */
    iLen = read(fhInp, puchReadBuffer, D_SZ_ATOK_DIC_AREA);
    close(fhInp);   /* input file close */
    if (iLen < 1) {
        fprintf(stderr, "t@C[%s]̓ǍɎs܂\n", atokfname);
        goto ERROR_EXIT;
    }
    fpOut = fopen(fnameOut, "w");
    if (fpOut == NULL) {
        rc = 1; /* error */
        printf("o̓t@C[%s]J܂\n", fnameOut);
        goto ERROR_EXIT;
    }
    rc = analizeMain(fpOut, puchReadBuffer);

ERROR_EXIT:;
    free(puchReadBuffer);
    if (fpOut != NULL) fclose(fpOut);
    return rc;
}
/* EOF */

