
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef _MSC_VER
#   include <io.h>
#else
#   define O_BINARY 0
#endif

#include "tokdef.h"

#define FALSE 0
#define D_SZ_ATOK_DIC_AREA  33752
#define D_OFFSET_DICSIZE 0x2410
#define D_OFFSET_WORDCNT 0x2412
#define D_OFFSET_IDXAREA_TOP 0x2414
#define D_OFFSET_DICAREA_TOP 0x2614
#define D_MAX_LINE_SIZE 4096

typedef struct tagWordToken {
    unsigned char uchStyle;         /* iԍ */
    unsigned char szYOMI[257];
    unsigned char szKNJ[257];
} TG_WORDTOKEN, *PTG_WORDTOKEN;

/* p}N */
typedef unsigned char UCHA;
#define isKcode1b(ch) ((UCHA)((ch^0x20)-0xa1) < 0x3c)
#define isKcode2b(ch) (((0x3f<(UCHA)(ch))&&((UCHA)(ch)<0x7f)) ||((0x7f<(UCHA)(ch))&&((UCHA)(ch)<0xfd)))
#define isKanji(pch)  (isKcode1b(pch[0])&&isKcode2b(pch[1]))

static char *zen1[] = { "@", "A", "B", "C", "D", "E", "F", "G", "H", "I",
    "J", "K", "L", "M", "N", "O", "P", "Q",
    "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "[", "\", "]", "^",
    "_", "`", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k",
    "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x",
    "y", "z", "{", "|", "}", "~", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "[",
          "I", "h", "", "", "", "", "f", "i", "j", "", "{", "C", "|", "D", "^",
    "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "F", "G", "", "", "", "H",
    "", "`", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n",
    "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "m", "", "n", "O", "Q",
    "e", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "o", "b", "p", "`",
    "B", "u", "v", "A", "E",
    NULL };

static char *zen2[] = { "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "[",
          "I", "h", "", "", "", "", "f", "i", "j", "", "{", "C", "|", "D", "^",
    "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "F", "G", "", "", "", "H",
    "", "`", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n",
    "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "m", "", "n", "O", "Q",
    "e", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "o", "b", "p", "`",
    "B", "u", "v", "A", "E",
    NULL };

static char *han[] = { "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "",
         "!", "\"","#", "$", "%", "&", "'", "(", ")", "*", "+", ",", "-", ".", "",
    "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ":", ";", "<", "=", ">", "?",
    "@", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O",
    "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "[", "\\", "]", "^", "_",
    "`", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o",
    "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "{", "|", "}", "~",
    "","","","","",
    NULL };

int ZenToHan(unsigned char *output, unsigned char *input) {
    UCHA *puch = (UCHA *)input;
    unsigned char buf[16];
    int i;
    UCHA c;
    do {
        if (*puch == 0x00) break;
        if (isKanji(puch)) {
            buf[0] = puch[0];
            buf[1] = puch[1];
            buf[2] = 0;
            for (i=0;;i++) {
                if (zen1[i] == NULL) {
                    *output++ = *puch++;
                    *output++ = *puch++;
                    break;
                }
                if (strcmp(zen1[i], buf) == 0){
                    strcpy(output, han[i]);
                    output += strlen(han[i]);
                    puch++;
                    puch++;
                    break;
                }
                if (strcmp(zen2[i], buf) == 0){
                    strcpy(output, han[i]);
                    output += strlen(han[i]);
                    puch++;
                    puch++;
                    break;
                }
            }
        } else {
            c = *puch++;
            if (c == 0x2f) c = 0xa5;
            *output++ = c;
        }
    } while (1);
    return 0;
}

/*
 *  ėp֐Q
 */
int getShortValue(unsigned char *puchBuf, int iOffset) {
    unsigned short *p;
    unsigned short s;
    p = (unsigned short *)(&puchBuf[iOffset]);
    s = *p;
    return (int)s;
}

void setShortValue(unsigned char *puchBuf, int iOffset, int iWordNum) {
    short *p;
    p = (short *)&puchBuf[iOffset];
    *p = (short)iWordNum;
}

void setDicSize(unsigned char *puchBuf, unsigned char *puchCurrentPos) {
    unsigned char *puchDicTop;
    long l;
    puchDicTop = &puchBuf[D_OFFSET_DICAREA_TOP];
    l = (long)(puchCurrentPos - puchDicTop);
    setShortValue(puchBuf, D_OFFSET_DICSIZE, (int)l);
}

void setWordNumber(unsigned char *puchBuf, int iWordNum) {
    setShortValue(puchBuf, D_OFFSET_WORDCNT, iWordNum);
}

/*
 *  
 */
void clearDicArea(unsigned char *puchBuf, int iLength) {
    unsigned char *puch;
    puch = &puchBuf[D_OFFSET_IDXAREA_TOP];
    memset(puch, 0xff, (D_OFFSET_DICAREA_TOP - D_OFFSET_IDXAREA_TOP));
    puch = &puchBuf[D_OFFSET_DICAREA_TOP];
    iLength -= D_OFFSET_DICAREA_TOP;
    memset(puch, 0, iLength);
}

/*
 *  e폈
 */
void setIndex(unsigned char *puchBuf, unsigned char uchFirstChar, unsigned char *puchCurrentPos) {
    unsigned short *p;
    unsigned short s;
    int iIdx;
    p = (unsigned short *)&puchBuf[D_OFFSET_IDXAREA_TOP];
    if (uchFirstChar == 0x2f) uchFirstChar = 0xa5;
    iIdx = (int)uchFirstChar;
    s = p[iIdx];
    if (s != 0xffff) return;
    s = (unsigned short)(puchCurrentPos - &puchBuf[D_OFFSET_DICAREA_TOP]);
    p[iIdx] = s;
}

int searchNextComma(int iStartPos, int iMax, unsigned char *puchBuf) {
    int iIndex;                         /* ʒuwCfBbNX     */
    int fbInQuote;                      /* NH[gotO               */
    unsigned char uch;                  /* pϐ                   */
    unsigned char *p;                   /* pϐ                   */

    iIndex = iStartPos;                 /* ʒuݒ肷               */
    fbInQuote = FALSE;                  /* Jn_ł̓NH[gȂ     */
    while (iIndex < iMax) {             /* obt@̏I[܂Ń[v         */
        uch = puchBuf[iIndex];          /* 1o                      */
        if (fbInQuote == FALSE) {       /* "`,`"͏Ȃ              */
            if (uch == 0x09) {          /* TAB?                           */
                break;
            }
            if (uch == ',') {           /* ,?                             */
                break;
            }
            p = &puchBuf[iIndex];
            if (isKanji(p)) {           /* f[^͂QoCgR[hH       */
                if (uch == 0x81) {      /* A?                            */
                    p++;
                    if (*p == 0x41) {
                        break;
                    }
                }
                iIndex++;               /* ̕                       */
                iIndex++;               /* 2oCgڂA4        */
                continue;
            }
            if (uch == 0xa4) {          /* ''?                           */
                break;
            }
        }
        if (uch == 0x22||uch == 0x27) { /* '":QuoteȂ΃[hύX         */
            fbInQuote = !fbInQuote;     /* [h𔽓]                 */
        }
        iIndex++;
    }                                   /* ̕                   */
    return iIndex;
}

/*
 *  'A' 0x8141 H
 */
int is8141(unsigned char *pszBuf, int idx) {
    unsigned char uchA = pszBuf[idx];
    unsigned char uchB = pszBuf[(idx+1)];
    if ((uchA == 0x81)&&(uchB == 0x41)) {
        return 1;
    }
    return 0;
}

/*
 *  ȉ̓CƂȂ鏈֐Q
 */

/* g[N𐶐 */
PTG_WORDTOKEN createWordToken(unsigned char *pszBuf, PTG_WORDTOKEN ptgWordToken) {
    PTG_WORDTOKEN ptgRc = NULL;
    unsigned char szYOMI[512];
    unsigned char szKNJ[512];
    unsigned char szHIN[256];
    char *pch;
    int iWk;
    int iStartPos;
    int iMax;
    int iNext;

    PATREGSTYLEBUF ptgWk;

    memset(ptgWordToken, 0, sizeof(TG_WORDTOKEN));      /* Alclear */
    iMax = strlen(pszBuf);
    /* ݂ */
    iStartPos = 0;
    iNext = searchNextComma(iStartPos, iMax, pszBuf);
    iWk = iNext - iStartPos;
    memset(szYOMI, 0, sizeof(szYOMI));
    memcpy(szYOMI, &pszBuf[iStartPos], iWk);
    /*  */
    if (is8141(pszBuf, iNext)) {
        iStartPos = iNext + 2;
    } else {
        iStartPos = iNext + 1;
    }
    iNext = searchNextComma(iStartPos, iMax, pszBuf);
    iWk = iNext - iStartPos;
    memset(szKNJ, 0, sizeof(szKNJ));
    memcpy(szKNJ, &pszBuf[iStartPos], iWk);
    /* i */
    if (is8141(pszBuf, iNext)) {
        iStartPos = iNext + 2;
    } else {
        iStartPos = iNext + 1;
    }
    iNext = searchNextComma(iStartPos, iMax, pszBuf);
    iWk = iNext - iStartPos;
    memset(szHIN, 0, sizeof(szHIN));
    if (iWk > sizeof(szHIN)) {
        iWk = sizeof(szHIN) - 1;
    }
    memcpy(szHIN, &pszBuf[iStartPos], iWk);
    for(iWk=0; iWk < sizeof(szHIN) - 1; iWk++) {
        if (szHIN[iWk] == '*') {
            szHIN[iWk] = 0;
            break;
        }
        if (szHIN[iWk] == '$') {
            szHIN[iWk] = 0;
            break;
        }
    }

    /* */
    iWk = ZenToHan(ptgWordToken->szYOMI, szYOMI);
    if (iWk < 0) {
        return NULL;
    }

    /* ̏:NH[gOăg */
    if (szKNJ[0] == '"') {
        iStartPos = 1;
        pch = strrchr(&szKNJ[1], '"');
    } else if (szKNJ[0] == 0x27) {
        iStartPos = 1;
        pch = strrchr(&szKNJ[1], 0x27);
    } else {
        iStartPos = 0;
        pch = strrchr(szKNJ, 0x00);
    }
    *pch = 0x00;
    do {
        pch--;
        if ((*pch == ' ')||(*pch == '\t')) {
            *pch = 0x00;
            continue;
        }
        break;
    } while(1);
    pch = &szKNJ[iStartPos];
    do {
        if (*pch == 0x00) break;
        if ((*pch == ' ')||(*pch == '\t')) {
            pch++;
            continue;
        }
        break;
    } while (1);
    strcpy(ptgWordToken->szKNJ, pch);

    /* iԍݒ */
    ptgRc = ptgWordToken;
    ptgWordToken->uchStyle = 1;
    ptgWk = atgRegStyle;
    do {
        if (ptgWk->pszDescription == NULL) {
            break;
        }
        if (strcmp(ptgWk->pszDescription, szHIN) == 0) {
            ptgWordToken->uchStyle = ptgWk->uchStyle;
            break;
        }
        ptgWk++;
    } while (1);
    return ptgRc;
}

/* ɓo^ */
unsigned char *addWordToken(unsigned char *puchBuf,
                            unsigned char *puchCurrent,
                            PTG_WORDTOKEN ptgWordToken) {
    int iLenY;
    int iLenK;
    unsigned char uchToken;
    unsigned char uchCode;

    iLenY = strlen(ptgWordToken->szYOMI);
    iLenK = strlen(ptgWordToken->szKNJ);
    uchCode = ptgWordToken->uchStyle;
    if (uchCode == 1) {
        uchToken = (unsigned char)(iLenY + iLenK + 1);
        uchToken = uchToken | 0x80;
    } else {
        uchToken = (unsigned char)(iLenY + iLenK + 2);
    }
    *puchCurrent++ = uchToken;                          /* S̒       */
    *puchCurrent++ = (unsigned char)iLenY;              /* ݂Ȓ   */
    memcpy(puchCurrent, ptgWordToken->szYOMI, iLenY);   /* ݂     */
    puchCurrent += iLenY;
    memcpy(puchCurrent, ptgWordToken->szKNJ, iLenK);    /*          */
    puchCurrent += iLenK;
    if (uchCode != 1) {
        *puchCurrent++ = uchCode;                       /* iԍ     */
    }
    return puchCurrent;
}

/* g[NSĕێA
 * R[hɃ\[g鏈Kv邪
 * ʓ|Ȃ̂ŏȗB(̓t@CSORTĂ)
 */
int convertMain(FILE *fpInp, unsigned char *puchBuf, int iLength) {
    int rc;
    unsigned char szBuf[D_MAX_LINE_SIZE + 1];
    char *pchInp;
    unsigned char *puchCurrentPos;
    PTG_WORDTOKEN ptgWordToken;
    TG_WORDTOKEN  tgWordToken;
    unsigned char uchFirstChar;
    int iLine = 0;
    int iWordCounter = 0;
    int iLen;

    /* area clear */
    clearDicArea(puchBuf, iLength);

    /* ϊJn */
    rc = 0; /* normal return code */
    iLine = 0;
    iWordCounter = 0;
    puchCurrentPos = &puchBuf[D_OFFSET_DICAREA_TOP];
    do {
        memset(szBuf, 0, sizeof(szBuf));
        pchInp = fgets(szBuf, D_MAX_LINE_SIZE, fpInp);
        if (pchInp == NULL) {
            /* file io error ? */
            if (ferror(fpInp)){
                rc = -1;
                break;
            }
            /* file end ? */
            if (feof(fpInp)){
                break;
            }
        }
        /* s폜 */
        pchInp = strrchr(szBuf, 0x00);
        do {
            pchInp--;
            if ((*pchInp == 0x0a)||(*pchInp == 0x0d)||(*pchInp == 0x09)||(*pchInp == 0x20)) {
                *pchInp = 0x00;
                continue;
            }
            break;
        } while(1);
        iLine++;
        if (szBuf[0] == '!') continue;
        if (strlen(szBuf) < 4) continue;

        /* g[N𐶐 */
        ptgWordToken = createWordToken(szBuf, &tgWordToken);
        if (ptgWordToken == NULL) {
            fprintf(stderr, "ERROR: Ill input data. LINE:%d input[%s]\n", iLine, szBuf);
            continue;
        }
        /* I[`FbN */
        iLen = strlen(ptgWordToken->szYOMI) + strlen(ptgWordToken->szKNJ) + 2;
        if ((puchCurrentPos + iLen) >= (puchBuf + iLength)) {
            fprintf(stderr, "ERROR: Overflow. LINE:%d input[%s] is not entry.\n", iLine, szBuf);
            break;
        }
        /* ɓo^ */
        uchFirstChar = ptgWordToken->szYOMI[0];
        setIndex(puchBuf, uchFirstChar, puchCurrentPos);
        puchCurrentPos = addWordToken(puchBuf, puchCurrentPos, ptgWordToken);
        /* ꐔƒݒ */
        setDicSize(puchBuf, puchCurrentPos);
        setWordNumber(puchBuf, ++iWordCounter);
    } while(1);
    return rc;
}

void calcSUM(unsigned char *puchReadBuffer, int iLen){
    int i=16;
    long lSum = 0;
    unsigned long *pul;
    for(;i<iLen;i++){
        lSum = lSum + puchReadBuffer[i];
    }
    pul = (unsigned long *)(&puchReadBuffer[4]);
    *pul = lSum;
}

void useage(char *thispgm) {
    printf("usegae:\n\t%s <input text filename> <orignal atok.dic> <output filename>\n", thispgm);
}

int main(int argc, char **argv) {
    int rc;
    int iDataSz;
    char *fnameIn;
    char *atokfname;
    char *fnameOut;
    FILE *fpInp;
    FILE *fpOut;
    int fhInp2;
    int iLen;
    unsigned char *puchReadBuffer;

    /* init */
    rc = 11;    /* Ill arg. */
    puchReadBuffer = NULL;
    fpInp = NULL;
    fpOut = NULL;
    fhInp2 = 0;

    if (argc < 4) {
        useage(argv[0]);
        return rc;
    }
    fnameIn = argv[1];
    if (fnameIn == NULL) {
        useage(argv[0]);
        return rc;
    }
    atokfname = argv[2];
    if (atokfname == NULL) {
        useage(argv[0]);
        return rc;
    }
    fnameOut = argv[3];
    if (fnameOut == NULL) {
        useage(argv[0]);
        return rc;
    }
    /* get resource */
    rc = 3; /* fatal error */
    puchReadBuffer = (unsigned char *)malloc(D_SZ_ATOK_DIC_AREA + 1); /* DM20̎TCYm  */
    if (puchReadBuffer == NULL) {
        return rc; /* resource failed. goto error processing. */
    }
    memset(puchReadBuffer, 0, D_SZ_ATOK_DIC_AREA);      /* ̈NA                   */
    /* file open */
    rc = 4; /* read error */
    fhInp2 = open(atokfname, O_RDONLY|O_BINARY);
    if (fhInp2 < 0) {
        printf("t@C[%s]J܂\n", atokfname);
        goto ERROR_EXIT;
    }
    /* IWi̓Ǎ */
    iLen = read(fhInp2, puchReadBuffer, 16);            /* 擪16oCg擾(header)   */
    iDataSz = getShortValue(puchReadBuffer, 0);         /* 擪2oCgc̃f[^ */
    iLen = read(fhInp2, &puchReadBuffer[16], iDataSz);  /* c̃f[^ǂݍ       */
    close(fhInp2);                                      /* input file close             */
    if (iLen < 1) {
        printf("t@C[%s]̓ǍɎs܂\n", atokfname);
        goto ERROR_EXIT;
    }
    iLen += 16;                                         /* f[^̈撷𒲐           */
    /* o^[hXg̓Ǎ */
    fpInp = fopen(fnameIn, "r");
    if (fpInp == NULL) {
        printf("̓t@C[%s]J܂\n", fnameIn);
        goto ERROR_EXIT;
    }
    /* call main logic. */
    rc = convertMain(fpInp, puchReadBuffer, iLen);
    if (rc != 0) {
        goto ERROR_EXIT;
    }
    /* `FbNTvZ */
    calcSUM(puchReadBuffer, iLen);
    /* ʂo */
    fpOut = fopen(fnameOut, "wb");
    if (fpOut == NULL) {
        rc = 1; /* error */
        printf("o̓t@C[%s]J܂\n", fnameOut);
        goto ERROR_EXIT;
    }
    fwrite(puchReadBuffer, (iDataSz+16), 1, fpOut);

ERROR_EXIT:;
    free(puchReadBuffer);
    if (fpOut != NULL) fclose(fpOut);
    if (fpInp != NULL) fclose(fpInp);
    return rc;
}
/* EOF */
